# DPFormer: Learning Differentially Private Transformer on Long-Tailed Data

## Installation
```python
conda create -n DPFormer python=3.8
conda activate DPFormer
conda install pytorch==1.11.0 cudatoolkit=11.3 -c pytorch
pip install -r requirements.txt
```

## Data preprocessing
* MovieLens: The raw data can be downloaded [here](https://grouplens.org/datasets/movielens/), where we use the version  MovieLens-1M.
* Amazon: The raw data can be downloaded [here](https://cseweb.ucsd.edu/~jmcauley/datasets.html#amazon_reviews), where we use the version Games.
```python
cd data
python script.py
```
## Reproduce the Transformer (vanilla)
```python
python main.py --config Transformer_ml1m
```
```python
python main.py --config Transformer_Amazon
```
## Reproduce the DPFormer
```python
python main.py --config DPFormer_ml1m
```
```python
python main.py --config DPformer_Amazon
```